
/* /////////////////////////////////////////////////
   COCO DTMF  4 ou 5 caractères
   2 ou 3 si le second code n'est pas une lettre.
   /////////////////////////////////////////////////

   Coco: Perroquet répèteur universel de codes DTMF
   Utilise un décodeur DTMF MT8870 & codeur TP5088
   

   Le code complet doit commencer par l'identifiant du perroquet ici "A" qui sera suivi de 4 caractères de télécommandes
   ou de seulement 3 si le troisième est un * ou un #  (conformément au protocole des relais de la région Rhône-Alpes Franche Comté)
   Sile A est suivi d'un B, C ou D se dernier s'ajoutera au code.

   Au dernier appui le code est automatiquement répété. Une Led clignote à la fin de l'envoi.

   Un contrôle du système est  possible via le moniteur série Arduino.
 
   F5MNA
   
   Version 1.0 Septembre 2014 
   Version 3.1 Novembre 2016
   Version 4.0 Novembre 2016  
   Version 5.0 Novembre 2016 
   
   http://f5mna.free.fr

   /////////////////////////////////////
*/

int DTMF;
int ConfDTMF = 3;    // Confirmation de réception d'un code DTMF Pin 3
int DTMF0 = 4;       // Sortie 0 MT8870 Pin  4
int DTMF1 = 5;       // Sortie 1 MT8870      5
int DTMF2 = 6;       // Sortie 2 MT8870      6
int DTMF3 = 7;       // Sortie 3 MT8870      7

int PERROQ_0 = 8;    // Entrée 0 TP5088      8
int PERROQ_1 = 9;    // Entrée 1 TP5088      9
int PERROQ_2 = 10;   // Entrée 2 TP5088      10
int PERROQ_3 = 11;   // Entrée 3 TP5088      11
//int UHF = A0;        // Commande Tx VHF/UHF (Actuellement C: Symbole en 2éme position
int Enable  = 13;    // Entrée validation du TP5088
int PTT = 12;        // PTT TX
int Led = 2;         // Led


int Buffer[35];    // Mémorisation du code
int Cod, x, ma, ma2;    // Nombre de codes à transmettre
int Coco;          // Codes à transmettre
int val;           // confirmation DTMF (ConfDTMF)
int buttonState;   // Prise en compte du changement d'état de la confirmation DTMF
boolean OK = false;// Gestion codes
boolean OK1 = true;// Gestion codes
boolean Bloc = false;// Gestion codes
boolean AM = true; // Passe de 6 à 5 symboles
boolean ma4 = false; // Passe à 3 symboles si une fois passé à 4 le 3ème est un * ou un #
int Tempo;         // Fenetre de temporisation.

void setup()
{
  Serial.begin (9600);
  pinMode (ConfDTMF, INPUT); // Validation code DTMF
  pinMode (DTMF0, INPUT); // Sortie MT8870
  pinMode (DTMF1, INPUT); // Sortie MT8870
  pinMode (DTMF2, INPUT); // Sortie MT8870
  pinMode (DTMF3, INPUT); // Sortie MT8870

  pinMode (PERROQ_0, OUTPUT); // Sortie TP5088
  pinMode (PERROQ_1, OUTPUT); // Sortie TP5088
  pinMode (PERROQ_2, OUTPUT); // Sortie TP5088
  pinMode (PERROQ_3, OUTPUT); // Sortie TP5088

  pinMode (Enable, OUTPUT);  // Entrée validation du TP5088
  pinMode (Led, OUTPUT);     // Led
  pinMode (PTT, OUTPUT);     // PTT TX
  
 // pinMode(UHF,OUTPUT);       // Commande Tx VHF/UHF (Actuellement C: Symbole en 2éme position
 // digitalWrite(UHF,LOW);
    
  Cod = 0;
  DTMF = 0;        // Sommes sorties DTMF
  Tempo = 0;  
  buttonState = digitalRead(ConfDTMF);
  ma2 = 1; //discrimination Symbole 2: lettre ou chiffre.
  
  //flash led à a mise en route
  for (int x = 0; x < 11; x++)
  {
    digitalWrite(Led, HIGH);
    delay(50);
    digitalWrite(Led, LOW);
    delay(50);
  }
  Serial.println ("Test Coco DTMF");
}

void Repet()
{
  for (int Cod = 1; Cod < ma + 1; Cod ++)
  {
    Coco = Buffer[Cod];

    if ((Bloc == false) and (Cod == 2)){ (digitalWrite(PTT, HIGH)); // PTT Tx
    delay (1000);} // Mise en route TX une seconde avant emission des codes
    if (OK1 == true)
    {
      digitalWrite(Enable, HIGH); // Active MP5088
    }
    else
    {
      digitalWrite(Enable, LOW); // Desactive MP5088
    }
    
   

    switch (Coco)
    {
     case 0: // D
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("D");
        //Serial.print ("     ");
        //Serial.println (Cod);
        break;
   
      case 1: // 1
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("1");
        break;

      case 2: // 2
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("2");
        break;

      case 3: // 3
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("3");
        break;

      case 4: // 4
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("4");
        break;

      case 5: // 5
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("5");
        break;

      case 6: // 6
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("6");
        break;

      case 7: // 7
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        Serial.println ("7");
        break;

      case 8: // 8
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("8");
        break;

      case 9: // 9
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("9");
        break;

      case 10:// 0
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("0");
        break;

      case 11: //*
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("*");
        break;

      case 12: //#
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("#");
        break;

      case 13: //A
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("A");
        break;

      case 14: //B
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("B");
        break;

      case 15: //C
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);
        Serial.println ("C");
        break;
    }
    delay(300) ;
    digitalWrite(Enable, LOW); // Désactive MP5088 (Temporisation codes)
    delay(300) ;
  }
  digitalWrite(PTT, LOW); // PTT Tx
  Cod = 0;
  for (int x = 0; x < 6; x++)
  {
    digitalWrite(Led, HIGH);
    delay(100);
    digitalWrite(Led, LOW);
    delay(100);
  }
  ma4 = false;
  ma2 = 1;
}

void loop ()  {

  AM = true;
  val = digitalRead(ConfDTMF); //Confirmation DTMF
  if (val != buttonState) { // Modification de cette valeur
    if (val == LOW) {
      DTMF = 0;
      Tempo = 0;
      if (digitalRead(DTMF3) == HIGH) DTMF = DTMF + 1;
      if (digitalRead(DTMF2) == HIGH) DTMF = DTMF + 2;
      if (digitalRead(DTMF1) == HIGH) DTMF = DTMF + 4;
      if (digitalRead(DTMF0) == HIGH) DTMF = DTMF + 8;

      switch (DTMF)
      {
        case 0: // "D"  
           Buffer[Cod] = 0;            
          if (Cod == 1){
          // digitalWrite(UHF,HIGH); 
           ma2 = 0;         
          }
         
          break;
        case 1: // "1"
          Buffer[Cod] = 1;
          if (Cod == 1) AM = false;
          break;
        case 2: // "2"
          Buffer[Cod] = 2;
          if (Cod == 1) AM = false;
          break;
        case 3: // "3"
          Buffer[Cod] = 3;
          if (Cod == 1) AM = false;
          break;
        case 4: // "4"
          Buffer[Cod] = 4;
          if (Cod == 1) AM = false;
          break;
        case 5: // "5"
          Buffer[Cod] = 5;
          if (Cod == 1) AM = false;
          break;
        case 6: // "6"
          Buffer[Cod] = 6;
          if (Cod == 1) AM = false;
          break;
        case 7: // "7"
          Buffer[Cod] = 7;
          if (Cod == 1) AM = false;
          break;
        case 8: // "8"
          Buffer[Cod] = 8;
          if (Cod == 1) AM = false;
          break;
        case 9:// "9"
          Buffer[Cod] = 9;
          if (Cod == 1) AM = false;
           break;
        case 10: // "0"
          Buffer[Cod] = 10;
          if (Cod == 1) AM = false;          
          break;

        case 11: // "*"
          AM = false;
          if (Cod == 3) ma4 = true;         
          Buffer[Cod] = 11;
          break;

        case 12: // "#"
          AM = false;
          if (Cod == 3) ma4 = true;
          Buffer[Cod] = 12;
          break;
        //Code d'identification du perroquet//

        case 13: // "A"
            Buffer[Cod] = 13; 
          if (OK == false) {
            Cod = 0;     // RAZ Buffer
            OK = true; 
          // digitalWrite(UHF, LOW);          
          }
          else
          {
            Buffer[Cod] = 13;
          // digitalWrite(UHF, LOW);
          }
          break;
        ////////////////////////////////
        case 14: // "B"
         Buffer[Cod] = 14;
         if (Cod == 1){
          ma2 = 0;
        // digitalWrite(UHF,LOW);
         }
          
          break;
        case 15: // "C"
           Buffer[Cod] = 15;
          if (Cod == 1){
           ma2 = 0;  
         // digitalWrite(UHF,LOW);          
          }
         
          
          break;
      }

      digitalWrite(Led, HIGH);
      delay (200);
      digitalWrite(Led, LOW);
   
      Serial.print ("Entree code    ");
      Serial.print ("DTMF: ");
      Serial.println (DTMF);
      
      if (OK == true) (Cod ++);
      if (AM == true)  (ma = 6-ma2); // Compte 6 ou 5 code
      if (AM == false) (ma = 5-ma2);


      if (Cod > (ma - 1)) {
        Tempo == 0;
        Cod == 0;
        OK = false;
        Repet();

      }
    }
  }
  buttonState = val; // Confirmation de la validation DTMF (CM8870)

  // Fenetre de temporisation
  if (OK == true) {
    Tempo ++;
    delay (5);
  }
  if ((Cod < ma) && (Tempo > 500)) {
    Tempo = 0;
    Cod == 0;
    OK = false;   
  }

}
// FIN



