
/* /////////////////////////////////////////////////
   COCO DTMF  Universel 
   /////////////////////////////////////////////////
   Coco: Perroquet répèteur universel de codes DTMF
   Utilise un décodeur DTMF MT8870 & codeur TP5088
   
   Après l'envoi d'un code précédé d'un identifiant (ici "A") un temps d'arrêt de deux 
   secondes environ déclenche la répétition. Ce perroquet fonctionne quelque soit le protocole.
   Version limitée à 20 symboles. La modification des paramètres n'offre aucune difficulté.  
     
   Version 1.0 Decembre 2016  
   
   http://f5mna.free.fr

/*////////////////////////////////////



int DTMF0 = 4;       // Sortie 0 MT8870 Pin  4
int DTMF1 = 5;       // Sortie 1 MT8870      5
int DTMF2 = 6;       // Sortie 2 MT8870      6
int DTMF3 = 7;       // Sortie 3 MT8870      7

int PERROQ_0 = 8;    // Entrée 0 TP5088      8
int PERROQ_1 = 9;    // Entrée 1 TP5088      9
int PERROQ_2 = 10;   // Entrée 2 TP5088      10
int PERROQ_3 = 11;   // Entrée 3 TP5088      11

int DTMF;            // Sommes 4 sorties DTMF
int Buffer[35];      // Mémorisation du code
int Cod, NbrCod;     // Nombre de codes à transmettre
int Coco;            // Codes à transmettre
int Tempo;           // Fenetre de temporisation.
int buttonState;     // Prise en compte du changement d'état de la confirmation DTMF
int ConfDTMF = 3;    // Confirmation de réception d'un code DTMF Pin 3
int val;             // confirmation DTMF (ConfDTMF)
int Enable  = 13;    // Entrée validation du TP5088
int Led = 2;         // Led
int PTT = 12;        // PTT TX

boolean OK = false;  // Gestion codes

void setup() {

  pinMode (ConfDTMF, INPUT); // Validation code DTMF
  pinMode (DTMF0, INPUT); // Sortie MT8870
  pinMode (DTMF1, INPUT); // Sortie MT8870
  pinMode (DTMF2, INPUT); // Sortie MT8870
  pinMode (DTMF3, INPUT); // Sortie MT8870

  pinMode (PERROQ_0, OUTPUT); // Sortie TP5088
  pinMode (PERROQ_1, OUTPUT); // Sortie TP5088
  pinMode (PERROQ_2, OUTPUT); // Sortie TP5088
  pinMode (PERROQ_3, OUTPUT); // Sortie TP5088

  pinMode (Enable, OUTPUT);  // Entrée validation du TP5088
  pinMode (Led, OUTPUT);     // Led
  pinMode (PTT, OUTPUT);     // PTT TX
  
  Cod = 0;
  NbrCod = 0;
  DTMF = 0;          // Sommes 4 sorties DTMF
  Tempo = 0;  
  buttonState = digitalRead(ConfDTMF);

  //flash led à a mise en route
  for (int x = 0; x < 11; x++)
  {
    digitalWrite(Led, HIGH);
    delay(50);
    digitalWrite(Led, LOW);
    delay(50);
  }
}

void Repet(){
   
 NbrCod = Cod; 
 
 for (int Cod = 1; Cod < (NbrCod + 1)  ; Cod ++)
 {
  
   Coco = Buffer[Cod]; // Lit le contenu de chaque case mémoire
   if  (Cod == 2){ (digitalWrite(PTT, HIGH)); // PTT Tx
   delay (500);}     // Mise en route TX une demi seconde avant emission des codes 
   if (Cod > 1) digitalWrite(Enable, HIGH); // Active MP5088 
  
   switch (Coco)
    {
     case 0: // D
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        break;
   
      case 1: // 1
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        break;

      case 2: // 2
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        break;

      case 3: // 3
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, LOW);
        break;

      case 4: // 4
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        break;

      case 5: // 5
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        break;

      case 6: // 6
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        break;

      case 7: // 7
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, LOW);
        break;

      case 8: // 8
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);
        break;

      case 9: // 9
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);  
        break;

      case 10:// 0
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);
        break;

      case 11: //*
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, LOW);
        digitalWrite(PERROQ_3, HIGH);
        break;

      case 12: //#
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);
        break;

      case 13: //A
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, LOW);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);

        break;

      case 14: //B
        digitalWrite(PERROQ_0, LOW);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);

        break;

      case 15: //C
        digitalWrite(PERROQ_0, HIGH);
        digitalWrite(PERROQ_1, HIGH);
        digitalWrite(PERROQ_2, HIGH);
        digitalWrite(PERROQ_3, HIGH);
     
        break;
    }
    delay(300) ;
    digitalWrite(Enable, LOW); // Désactive MP5088 (Temporisation codes)
    delay(300) ;
 }

    digitalWrite(PTT, LOW); // PTT Tx
    Cod = 0;
    for (int x = 0; x < 6; x++)
    {
    digitalWrite(Led, HIGH);
    delay(100);
    digitalWrite(Led, LOW);
    delay(100);
   }
 }
////////////////////////////////////////////////////////////////////////
void loop() {

  val = digitalRead(ConfDTMF); //Confirmation DTMF
  if (val != buttonState) { // Modification de cette valeur
  if (val == LOW) {
      DTMF = 0;
      Tempo = 0;
      if (digitalRead(DTMF3) == HIGH) DTMF = DTMF + 1;
      if (digitalRead(DTMF2) == HIGH) DTMF = DTMF + 2;
      if (digitalRead(DTMF1) == HIGH) DTMF = DTMF + 4;
      if (digitalRead(DTMF0) == HIGH) DTMF = DTMF + 8;
      
    switch (DTMF)
      {
        case 0: // "D"  
           Buffer[Cod] = 0;                  
          break;
          
        case 1: // "1"
          Buffer[Cod] = 1;
          break;
          
        case 2: // "2"
          Buffer[Cod] = 2;
          break;
          
        case 3: // "3"
          Buffer[Cod] = 3;
          break;
          
        case 4: // "4"
          Buffer[Cod] = 4;
          break;
          
        case 5: // "5"
          Buffer[Cod] = 5;
          break;
          
        case 6: // "6"
          Buffer[Cod] = 6;
          break;
          
        case 7: // "7"
          Buffer[Cod] = 7;
          break;
          
        case 8: // "8"
          Buffer[Cod] = 8;
          break;
          
        case 9:// "9"
          Buffer[Cod] = 9;
          break;
          
        case 10: // "0"
          Buffer[Cod] = 10;       
          break;

        case 11: // "*" 
          Buffer[Cod] = 11;
          break;

        case 12: // "#"
          Buffer[Cod] = 12;
          break;
          
        //Code d'identification du perroquet//
        case 13: // "A"
          Buffer[Cod] = 13;  
          OK = true;   // Prise en compte des codes (Jora)             
          break;
        
        case 14: // "B"
         Buffer[Cod] = 14;
         break;
        
        case 15: // "C"
           Buffer[Cod] = 15;          
          break;   
      }

 digitalWrite(Led, HIGH);
 delay (200);
 digitalWrite(Led, LOW);
   
 if (OK == true) (Cod ++);  
}}   

 // Confirmation de la validation DTMF (CM8870) 
 buttonState = val;
  
 // Fenêtre de temporisation 
 if (OK == true) {  
    Tempo ++;
    delay (5);
       
  }   
  if ((Tempo > 400) or (Cod == 20)) {  // fenêtre Temps =  2.5 secondes (5*400ms + 500 )  -----  Limitation à 20 codes 
     Tempo = 0;
     OK = false;
     Repet();
     }
}
